# cocoTB AXI

Here is an example subsystem for using cocoTB to interface with an AXI system. 
The subsystem comprises of:
    - NIC400 bus interconnect
    - DMA350 direct memory access controller
    - 2x BP140 internal AXI memories with behavioural SRAMs

The subsytem is supplied as configuration files which have to be compiled using ARM Socrates, or configuration scripts from ARM.

The NIC400 is configure with 2 Master/Initiator ports, and 3 Slave/Subordinate ports. The 2 masters are connected to the 2 SRAMs (SRAM0 and SRAM1). The 3 slave ports are for the debug port, DMA M0, and DMA M1. 

The address map is: 

`SRAM0 : 0x00000000 - 0x0000FFFF   &   0x08000000 - 0x0800FFFF`

`SRAM1 : 0x10000000 - 0x1000FFFF   &   0x18000000 - 0x1800FFFF`


## Pre-requisites
To configure and run this subsystem you need:
    ARM - Socrates (1.7.3 or later)
    Python (tested on 3.6.8)
    cocotb (tested on 1.6.2)
    cocotb-bus (tested on 0.2.0)
    cocotbext-axi (tested on 0.1.24)

Seperate IP you will need is NIC400, DMA350, and BP140. You will also need a license for the socrates interconnect assistant for NIC400. This is all available under Arm Academic Access.
You will also need to associate these IPs with socrates.

For the DMA configuration, the makefile uses the generate script provided as part of the IP. The makefile uses the $ARM_IP_LIBRARY_PATH environment variable to find the IP, you will have to make sure this is pointing to the correct location in your system.
You will also have to copy the socrates/dma350/config/address_amp_m1_example2.sv

## Usage
To configure the IP, you can use the makefile at the top of the repository just run:
`make all`
This will first make a socrates project and then configure the NIC400, BP140 and DMA350

To run the cocoTB tests, run `make` from the verif/ directory. 

## License
A joint work commissioned on behalf of SoC Labs, under Arm Academic Access license.
For access to the ARM IP you will need to contact ARM directly
